include "chat.iol"
include "console.iol"

outputPort Chat {
Location: "socket://localhost:8000/"
Protocol: sodep
Interfaces: ChatInterface
}

inputPort MyInput {
Location: "socket://localhost:8002/"
Protocol: sodep
Interfaces: ClientInterface
}

main
{
	if ( args[0] == "open" ) {
		openReq.username = args[1];
		openReq.roomName = args[2];
		openRoom@Chat( openReq )()
	} else if ( args[0] == "pub" ) {
		pubReq.username = args[1];
		pubReq.roomName = args[2];
		pubReq.message = args[3];
		publish@Chat( pubReq )()
	} else if ( args[0] == "hist" ) {
		req.roomName = args[1];
		getHistory@Chat( req )( history );
		println@Console( history )()
	} else if ( args[0] == "enter" ) {
		req.roomName = args[1];
		req.location =
			global.inputPorts.MyInput.location;
		enterRoom@Chat( req )();
		while( true ) {
			update( upd );
			m = "[" + upd.roomName + "] "
				+ upd.username + ": "
				+ upd.message;
			println@Console( m )()
		}
	}
}
